// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from weight_scale_interfaces:action/GetWeight.idl
// generated code does not contain a copyright notice

#ifndef WEIGHT_SCALE_INTERFACES__ACTION__DETAIL__GET_WEIGHT__STRUCT_HPP_
#define WEIGHT_SCALE_INTERFACES__ACTION__DETAIL__GET_WEIGHT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_Goal __attribute__((deprecated))
#else
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_Goal __declspec(deprecated)
#endif

namespace weight_scale_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct GetWeight_Goal_
{
  using Type = GetWeight_Goal_<ContainerAllocator>;

  explicit GetWeight_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->timeout = 0.0;
    }
  }

  explicit GetWeight_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->timeout = 0.0;
    }
  }

  // field types and members
  using _timeout_type =
    double;
  _timeout_type timeout;

  // setters for named parameter idiom
  Type & set__timeout(
    const double & _arg)
  {
    this->timeout = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_Goal
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_Goal
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetWeight_Goal_ & other) const
  {
    if (this->timeout != other.timeout) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetWeight_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetWeight_Goal_

// alias to use template instance with default allocator
using GetWeight_Goal =
  weight_scale_interfaces::action::GetWeight_Goal_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace weight_scale_interfaces


// Include directives for member types
// Member 'weight'
#include "weight_scale_interfaces/msg/detail/weight__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_Result __attribute__((deprecated))
#else
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_Result __declspec(deprecated)
#endif

namespace weight_scale_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct GetWeight_Result_
{
  using Type = GetWeight_Result_<ContainerAllocator>;

  explicit GetWeight_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : weight(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  explicit GetWeight_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : weight(_alloc, _init),
    message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  // field types and members
  using _weight_type =
    weight_scale_interfaces::msg::Weight_<ContainerAllocator>;
  _weight_type weight;
  using _success_type =
    bool;
  _success_type success;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__weight(
    const weight_scale_interfaces::msg::Weight_<ContainerAllocator> & _arg)
  {
    this->weight = _arg;
    return *this;
  }
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_Result
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_Result
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetWeight_Result_ & other) const
  {
    if (this->weight != other.weight) {
      return false;
    }
    if (this->success != other.success) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetWeight_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetWeight_Result_

// alias to use template instance with default allocator
using GetWeight_Result =
  weight_scale_interfaces::action::GetWeight_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace weight_scale_interfaces


// Include directives for member types
// Member 'weight'
// already included above
// #include "weight_scale_interfaces/msg/detail/weight__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_Feedback __declspec(deprecated)
#endif

namespace weight_scale_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct GetWeight_Feedback_
{
  using Type = GetWeight_Feedback_<ContainerAllocator>;

  explicit GetWeight_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : weight(_init)
  {
    (void)_init;
  }

  explicit GetWeight_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : weight(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _weight_type =
    weight_scale_interfaces::msg::Weight_<ContainerAllocator>;
  _weight_type weight;

  // setters for named parameter idiom
  Type & set__weight(
    const weight_scale_interfaces::msg::Weight_<ContainerAllocator> & _arg)
  {
    this->weight = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_Feedback
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_Feedback
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetWeight_Feedback_ & other) const
  {
    if (this->weight != other.weight) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetWeight_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetWeight_Feedback_

// alias to use template instance with default allocator
using GetWeight_Feedback =
  weight_scale_interfaces::action::GetWeight_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace weight_scale_interfaces


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "weight_scale_interfaces/action/detail/get_weight__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_SendGoal_Request __declspec(deprecated)
#endif

namespace weight_scale_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct GetWeight_SendGoal_Request_
{
  using Type = GetWeight_SendGoal_Request_<ContainerAllocator>;

  explicit GetWeight_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit GetWeight_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const weight_scale_interfaces::action::GetWeight_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_SendGoal_Request
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_SendGoal_Request
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetWeight_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetWeight_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetWeight_SendGoal_Request_

// alias to use template instance with default allocator
using GetWeight_SendGoal_Request =
  weight_scale_interfaces::action::GetWeight_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace weight_scale_interfaces


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_SendGoal_Response __declspec(deprecated)
#endif

namespace weight_scale_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct GetWeight_SendGoal_Response_
{
  using Type = GetWeight_SendGoal_Response_<ContainerAllocator>;

  explicit GetWeight_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit GetWeight_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_SendGoal_Response
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_SendGoal_Response
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetWeight_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetWeight_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetWeight_SendGoal_Response_

// alias to use template instance with default allocator
using GetWeight_SendGoal_Response =
  weight_scale_interfaces::action::GetWeight_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace weight_scale_interfaces

namespace weight_scale_interfaces
{

namespace action
{

struct GetWeight_SendGoal
{
  using Request = weight_scale_interfaces::action::GetWeight_SendGoal_Request;
  using Response = weight_scale_interfaces::action::GetWeight_SendGoal_Response;
};

}  // namespace action

}  // namespace weight_scale_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_GetResult_Request __declspec(deprecated)
#endif

namespace weight_scale_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct GetWeight_GetResult_Request_
{
  using Type = GetWeight_GetResult_Request_<ContainerAllocator>;

  explicit GetWeight_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit GetWeight_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_GetResult_Request
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_GetResult_Request
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetWeight_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetWeight_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetWeight_GetResult_Request_

// alias to use template instance with default allocator
using GetWeight_GetResult_Request =
  weight_scale_interfaces::action::GetWeight_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace weight_scale_interfaces


// Include directives for member types
// Member 'result'
// already included above
// #include "weight_scale_interfaces/action/detail/get_weight__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_GetResult_Response __declspec(deprecated)
#endif

namespace weight_scale_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct GetWeight_GetResult_Response_
{
  using Type = GetWeight_GetResult_Response_<ContainerAllocator>;

  explicit GetWeight_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit GetWeight_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const weight_scale_interfaces::action::GetWeight_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_GetResult_Response
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_GetResult_Response
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetWeight_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetWeight_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetWeight_GetResult_Response_

// alias to use template instance with default allocator
using GetWeight_GetResult_Response =
  weight_scale_interfaces::action::GetWeight_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace weight_scale_interfaces

namespace weight_scale_interfaces
{

namespace action
{

struct GetWeight_GetResult
{
  using Request = weight_scale_interfaces::action::GetWeight_GetResult_Request;
  using Response = weight_scale_interfaces::action::GetWeight_GetResult_Response;
};

}  // namespace action

}  // namespace weight_scale_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "weight_scale_interfaces/action/detail/get_weight__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__weight_scale_interfaces__action__GetWeight_FeedbackMessage __declspec(deprecated)
#endif

namespace weight_scale_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct GetWeight_FeedbackMessage_
{
  using Type = GetWeight_FeedbackMessage_<ContainerAllocator>;

  explicit GetWeight_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit GetWeight_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const weight_scale_interfaces::action::GetWeight_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_FeedbackMessage
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__weight_scale_interfaces__action__GetWeight_FeedbackMessage
    std::shared_ptr<weight_scale_interfaces::action::GetWeight_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetWeight_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetWeight_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetWeight_FeedbackMessage_

// alias to use template instance with default allocator
using GetWeight_FeedbackMessage =
  weight_scale_interfaces::action::GetWeight_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace weight_scale_interfaces

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace weight_scale_interfaces
{

namespace action
{

struct GetWeight
{
  /// The goal message defined in the action definition.
  using Goal = weight_scale_interfaces::action::GetWeight_Goal;
  /// The result message defined in the action definition.
  using Result = weight_scale_interfaces::action::GetWeight_Result;
  /// The feedback message defined in the action definition.
  using Feedback = weight_scale_interfaces::action::GetWeight_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = weight_scale_interfaces::action::GetWeight_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = weight_scale_interfaces::action::GetWeight_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = weight_scale_interfaces::action::GetWeight_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct GetWeight GetWeight;

}  // namespace action

}  // namespace weight_scale_interfaces

#endif  // WEIGHT_SCALE_INTERFACES__ACTION__DETAIL__GET_WEIGHT__STRUCT_HPP_
