// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from weight_scale_interfaces:action/SetZero.idl
// generated code does not contain a copyright notice

#ifndef WEIGHT_SCALE_INTERFACES__ACTION__DETAIL__SET_ZERO__STRUCT_H_
#define WEIGHT_SCALE_INTERFACES__ACTION__DETAIL__SET_ZERO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in action/SetZero in the package weight_scale_interfaces.
typedef struct weight_scale_interfaces__action__SetZero_Goal
{
  /// sec
  double timeout;
} weight_scale_interfaces__action__SetZero_Goal;

// Struct for a sequence of weight_scale_interfaces__action__SetZero_Goal.
typedef struct weight_scale_interfaces__action__SetZero_Goal__Sequence
{
  weight_scale_interfaces__action__SetZero_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} weight_scale_interfaces__action__SetZero_Goal__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'message'
#include "rosidl_runtime_c/string.h"

/// Struct defined in action/SetZero in the package weight_scale_interfaces.
typedef struct weight_scale_interfaces__action__SetZero_Result
{
  bool success;
  rosidl_runtime_c__String message;
} weight_scale_interfaces__action__SetZero_Result;

// Struct for a sequence of weight_scale_interfaces__action__SetZero_Result.
typedef struct weight_scale_interfaces__action__SetZero_Result__Sequence
{
  weight_scale_interfaces__action__SetZero_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} weight_scale_interfaces__action__SetZero_Result__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'weight'
#include "weight_scale_interfaces/msg/detail/weight__struct.h"

/// Struct defined in action/SetZero in the package weight_scale_interfaces.
typedef struct weight_scale_interfaces__action__SetZero_Feedback
{
  weight_scale_interfaces__msg__Weight weight;
} weight_scale_interfaces__action__SetZero_Feedback;

// Struct for a sequence of weight_scale_interfaces__action__SetZero_Feedback.
typedef struct weight_scale_interfaces__action__SetZero_Feedback__Sequence
{
  weight_scale_interfaces__action__SetZero_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} weight_scale_interfaces__action__SetZero_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'goal'
#include "weight_scale_interfaces/action/detail/set_zero__struct.h"

/// Struct defined in action/SetZero in the package weight_scale_interfaces.
typedef struct weight_scale_interfaces__action__SetZero_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  weight_scale_interfaces__action__SetZero_Goal goal;
} weight_scale_interfaces__action__SetZero_SendGoal_Request;

// Struct for a sequence of weight_scale_interfaces__action__SetZero_SendGoal_Request.
typedef struct weight_scale_interfaces__action__SetZero_SendGoal_Request__Sequence
{
  weight_scale_interfaces__action__SetZero_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} weight_scale_interfaces__action__SetZero_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.h"

/// Struct defined in action/SetZero in the package weight_scale_interfaces.
typedef struct weight_scale_interfaces__action__SetZero_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} weight_scale_interfaces__action__SetZero_SendGoal_Response;

// Struct for a sequence of weight_scale_interfaces__action__SetZero_SendGoal_Response.
typedef struct weight_scale_interfaces__action__SetZero_SendGoal_Response__Sequence
{
  weight_scale_interfaces__action__SetZero_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} weight_scale_interfaces__action__SetZero_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"

/// Struct defined in action/SetZero in the package weight_scale_interfaces.
typedef struct weight_scale_interfaces__action__SetZero_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} weight_scale_interfaces__action__SetZero_GetResult_Request;

// Struct for a sequence of weight_scale_interfaces__action__SetZero_GetResult_Request.
typedef struct weight_scale_interfaces__action__SetZero_GetResult_Request__Sequence
{
  weight_scale_interfaces__action__SetZero_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} weight_scale_interfaces__action__SetZero_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "weight_scale_interfaces/action/detail/set_zero__struct.h"

/// Struct defined in action/SetZero in the package weight_scale_interfaces.
typedef struct weight_scale_interfaces__action__SetZero_GetResult_Response
{
  int8_t status;
  weight_scale_interfaces__action__SetZero_Result result;
} weight_scale_interfaces__action__SetZero_GetResult_Response;

// Struct for a sequence of weight_scale_interfaces__action__SetZero_GetResult_Response.
typedef struct weight_scale_interfaces__action__SetZero_GetResult_Response__Sequence
{
  weight_scale_interfaces__action__SetZero_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} weight_scale_interfaces__action__SetZero_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "weight_scale_interfaces/action/detail/set_zero__struct.h"

/// Struct defined in action/SetZero in the package weight_scale_interfaces.
typedef struct weight_scale_interfaces__action__SetZero_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  weight_scale_interfaces__action__SetZero_Feedback feedback;
} weight_scale_interfaces__action__SetZero_FeedbackMessage;

// Struct for a sequence of weight_scale_interfaces__action__SetZero_FeedbackMessage.
typedef struct weight_scale_interfaces__action__SetZero_FeedbackMessage__Sequence
{
  weight_scale_interfaces__action__SetZero_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} weight_scale_interfaces__action__SetZero_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // WEIGHT_SCALE_INTERFACES__ACTION__DETAIL__SET_ZERO__STRUCT_H_
