// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from weight_scale_interfaces:msg/Weight.idl
// generated code does not contain a copyright notice

#ifndef WEIGHT_SCALE_INTERFACES__MSG__DETAIL__WEIGHT__STRUCT_HPP_
#define WEIGHT_SCALE_INTERFACES__MSG__DETAIL__WEIGHT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__weight_scale_interfaces__msg__Weight __attribute__((deprecated))
#else
# define DEPRECATED__weight_scale_interfaces__msg__Weight __declspec(deprecated)
#endif

namespace weight_scale_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Weight_
{
  using Type = Weight_<ContainerAllocator>;

  explicit Weight_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->stable = false;
      this->overload = false;
      this->weight = 0.0;
      this->unit = "";
    }
  }

  explicit Weight_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init),
    unit(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->stable = false;
      this->overload = false;
      this->weight = 0.0;
      this->unit = "";
    }
  }

  // field types and members
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;
  using _stable_type =
    bool;
  _stable_type stable;
  using _overload_type =
    bool;
  _overload_type overload;
  using _weight_type =
    double;
  _weight_type weight;
  using _unit_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _unit_type unit;

  // setters for named parameter idiom
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }
  Type & set__stable(
    const bool & _arg)
  {
    this->stable = _arg;
    return *this;
  }
  Type & set__overload(
    const bool & _arg)
  {
    this->overload = _arg;
    return *this;
  }
  Type & set__weight(
    const double & _arg)
  {
    this->weight = _arg;
    return *this;
  }
  Type & set__unit(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->unit = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    weight_scale_interfaces::msg::Weight_<ContainerAllocator> *;
  using ConstRawPtr =
    const weight_scale_interfaces::msg::Weight_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<weight_scale_interfaces::msg::Weight_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<weight_scale_interfaces::msg::Weight_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::msg::Weight_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::msg::Weight_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      weight_scale_interfaces::msg::Weight_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<weight_scale_interfaces::msg::Weight_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<weight_scale_interfaces::msg::Weight_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<weight_scale_interfaces::msg::Weight_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__weight_scale_interfaces__msg__Weight
    std::shared_ptr<weight_scale_interfaces::msg::Weight_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__weight_scale_interfaces__msg__Weight
    std::shared_ptr<weight_scale_interfaces::msg::Weight_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Weight_ & other) const
  {
    if (this->stamp != other.stamp) {
      return false;
    }
    if (this->stable != other.stable) {
      return false;
    }
    if (this->overload != other.overload) {
      return false;
    }
    if (this->weight != other.weight) {
      return false;
    }
    if (this->unit != other.unit) {
      return false;
    }
    return true;
  }
  bool operator!=(const Weight_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Weight_

// alias to use template instance with default allocator
using Weight =
  weight_scale_interfaces::msg::Weight_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace weight_scale_interfaces

#endif  // WEIGHT_SCALE_INTERFACES__MSG__DETAIL__WEIGHT__STRUCT_HPP_
